from pyecharts.charts import Tree
import pandas as pd

def event_basic(basic_info):
    return basic_info[['event_name','event_desc']].rename(
        columns={'event_name':'事件名称','event_desc':'近期事件'})

def event_members(event_members):
    return event_members.rename(columns={
        'tid':'编号','trade_date':'交易日','title':'主题名称',
        'event':'驱动事件','sentiment':'市场情绪','returns':'昨收益','update_time':'爆发时间'})

def event_timeling(timeline, basic_info):
    event_list = []
    children = []
    timeline = timeline.copy()
    timeline['start_time'] = timeline['start_time'].dt.strftime('%Y-%m-%d')
    timeline['name'] = '(' + timeline['start_time'] + '):' + timeline['event_desc']
    for classify in timeline.event_classify.unique().tolist():
        ct = {}
        sub_event = timeline.set_index('event_classify').loc[classify]
        ct['name'] = classify
        if not isinstance(sub_event, pd.DataFrame):
            ct['children'] = [{'name':sub_event['name']}]
        else:
            ct['children'] = sub_event[['name']].to_dict(orient='records')
        children.append(ct)
    event_list.append({'name':basic_info.loc[0]['event_name'],'children':children})
    tree = Tree()
    tree.add("",event_list,collapse_interval=2)
    return tree